unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, BoldDM, ExtCtrls, BoldNavigatorDefs, BoldNavigator, StdCtrls,
  BoldListBox, BoldSubscription, BoldHandles, BoldRootedHandles,
  BoldAbstractListHandle, BoldCursorHandle, BoldListHandle, Grids, BoldGrid,
  BoldEdit, BusinessClasses, DBGrids, DB, BoldDataSet,
  BoldPropertiesController, BoldElements, BoldControlPack,
  BoldStringControlPack, BoldAttributes;

type
  TForm1 = class(TForm)
    AllOrders: TBoldListHandle;
    BoldListBox1: TBoldListBox;
    BoldNavigator1: TBoldNavigator;
    AllLines: TBoldListHandle;
    BoldNavigator2: TBoldNavigator;
    BoldGrid1: TBoldGrid;
    BoldGrid2: TBoldGrid;
    allProducts: TBoldListHandle;
    BoldNavigator3: TBoldNavigator;
    Button1: TButton;
    Button2: TButton;
    BoldDataSet1: TBoldDataSet;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    BoldPropertiesController1: TBoldPropertiesController;
    CurrencyRenderer: TBoldAsStringRenderer;
    BoldEdit1: TBoldEdit;
    BoldListBox2: TBoldListBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    function CurrencyRendererGetAsString(Element: TBoldElement;
      Representation: Integer; Expression: String): String;
    procedure CurrencyRendererSubscribe(Element: TBoldElement;
      Representation: Integer; Expression: String;
      Subscriber: TBoldSubscriber);
    procedure CurrencyRendererSetColor(Element: TBoldElement;
      var AColor: TColor; Representation: Integer; Expression: String);
    function CurrencyRendererMayModify(Element: TBoldElement;
      Representation: Integer; Expression: String;
      Subscriber: TBoldSubscriber): Boolean;
    function CurrencyRendererValidateCharacter(Element: TBoldElement;
      Value: String; Representation: Integer; Expression: String): Boolean;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  CurrentOrderLine: TOrderLine;
  CurrentProduct: TProduct;
begin
  CurrentOrderLine := allLines.CurrentBoldObject as TOrderLine;
  CurrentProduct := allProducts.CurrentBoldObject as TProduct;
  if CurrentOrderLine <> nil then
    begin
      CurrentOrderLine.product := CurrentProduct;
      CurrentOrderLine.price := CurrentProduct.price;
    end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  CurrentOrder: TOrder;
  CurrentOrderLine: TOrderLine;
  CurrentProduct: TProduct;
begin
{  CurrentOrder := allOrders.CurrentBoldObject as TOrder;
  CurrentOrderLine := CurrentOrder.orderLines.AddNew;
  CurrentProduct := allProducts.CurrentBoldObject as TProduct;
  if CurrentOrderLine <> nil then
    begin
      CurrentOrderLine.product := CurrentProduct;
    end; }
end;

function TForm1.CurrencyRendererGetAsString(Element: TBoldElement;
  Representation: Integer; Expression: String): String;
var
  IE: TBoldIndirectElement;
  ResultElement: TBoldElement;
begin
  Result := '';
  if Assigned(Element) then
  begin
    IE := TBoldIndirectElement.Create;
    try
      Element.EvaluateExpression(Expression, IE);
      ResultElement := IE.Value;
      if ResultElement is TBACurrency then
        begin
          Result := Format('%.2f',[TBACurrency(ResultElement).asCurrency]);
        end
      else
        Result := ResultElement.AsString;
    finally
      IE.Free;
    end;
  end;
end;

procedure TForm1.CurrencyRendererSubscribe(Element: TBoldElement;
  Representation: Integer; Expression: String;
  Subscriber: TBoldSubscriber);
begin
  Element.SubscribeToExpression(Expression, Subscriber, False);
end;

procedure TForm1.CurrencyRendererSetColor(Element: TBoldElement;
  var AColor: TColor; Representation: Integer; Expression: String);
var
  IE: TBoldIndirectElement;
  ResultElement: TBoldElement;
begin
  if Assigned(Element) then
  begin
    IE := TBoldIndirectElement.Create;
    try
      Element.EvaluateExpression(Expression, IE);
      ResultElement := IE.Value;
      if ResultElement is TBACurrency then
        begin
          if TBACurrency(ResultElement).asCurrency > 10 then
            case Representation of
              0: AColor := clRed;
              1: AColor := clGreen;
              2: AColor := clBlue;
            end;
        end;
    finally
      IE.Free;
    end;
  end;
end;

function TForm1.CurrencyRendererMayModify(Element: TBoldElement;
  Representation: Integer; Expression: String;
  Subscriber: TBoldSubscriber): Boolean;
begin
  result := Element.EvaluateExpressionAsDirectElement(Expression).ObserverMayModify(subscriber);
end;

function TForm1.CurrencyRendererValidateCharacter(Element: TBoldElement;
  Value: String; Representation: Integer; Expression: String): Boolean;
begin
  Result :=  (Pos('7',Value) = 0);
end;

end.
